;-------------------------------
;test rs232 komunikacije
;termometer
;straser silvo
;-------------------------------

	list p=16f628
	
#include "d:\asm\p16f628.inc"
#define PIN_1WIRE PORTA,3

#define EN PORTA,7
#define RW PORTA,1
#define RS PORTA,0
#define VRSTA1 b'10000000'
#define VRSTA2 b'11000000'

	cblock 0x20
	TMP,WTMP,STMP,T1,T2,T3,STEVEC,ENICA,DTICA,STICA,TEMPERATURA,DECIMALKA
	DATA_1W,TMP_1WIRE,COUNT_1W,L_RES,H_RES
	LCD_DATA,LCD_TMP,T1_LCD,T2_LCD,ST_ZNAKOV

	endc

	
	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _BODEN_ON & _LVP_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT
	
	org 0
	goto GLAVNI
	org 0x04
	goto PREKINITEV
	
	org 0x05
TABELA1
	addwf PCL,f
	DT "www2.maxi.si - forum o elektroniki in racunalnistvu ",.13,0
TABELA2
	addwf PCL,f
	DT "0123456789 "
TABELA3
	addwf PCL,f
	DT "Trenutna temperatura: ",0	
	

;-----------------------------------------
;prekinitvena rutina
PREKINITEV
	movwf WTMP
	swapf STATUS,W
	movwf STMP
	clrf STATUS
	btfsc PIR1,RCIF
	goto RC_INT
KONEC_P
	swapf STMP,W
	movwf STATUS
	swapf WTMP,F
	swapf WTMP,W
	retfie
	
	
RC_INT
	movlw .16
	subwf ST_ZNAKOV,W
	btfsc STATUS,C
	goto BRISI_V2
	movf ST_ZNAKOV,w
	addlw VRSTA2
	call UKAZ
	movf RCREG,W
	call NA_LCD
	incf ST_ZNAKOV,f
	goto KONEC_P	 	

BRISI_V2
	movlw VRSTA2
	call UKAZ
PONOVI
	movlw ' '
	call NA_LCD
	decfsz ST_ZNAKOV,f
	goto PONOVI
	goto KONEC_P
	
	
	
;----------------------------------------
;procedura pretvori vrednost v enem
;8 bitnem registru v 3 primerne za prilaz
;----------------------------------------
HEX_DEC	
	movwf ENICA	
	clrf STICA
	clrf DTICA
NA_STOTICO	
	movlw .100
	subwf ENICA,w
	btfss STATUS,C
	goto NA_DESETICO
	incf STICA,F
	movwf ENICA	
	goto NA_STOTICO
NA_DESETICO
	movlw .10
	subwf ENICA,w
	btfss STATUS,C
	return
	incf DTICA,f
	movwf ENICA
	goto NA_DESETICO
	
	
;----------------------------------------
;pavza 
;---------------------------------------		
PAUZA
	movlw .255
	movwf T1
	movwf T2
	movlw .6
	movwf T3
Z1	
	decfsz T1,f
	goto Z1
	decfsz T2,f
	goto Z1
	decfsz T3,f
	goto Z1
	return

;----------------------------------------
;procedura caka do konca poslanega 
;podatka
;---------------------------------------
CAKAJ
	bsf STATUS,RP0
	btfss TXSTA,TRMT
	goto $-1
	bcf STATUS,RP0
	return

;**********************************************************
;rutine 1WIRE

;-------------------------------------------------- 	
;reset 1WIRE
;procedura resetira senzor 1wire
;--------------------------------------------------
RESET1W
	call L1WIRE		;1wire pin je nizek
	movlw .49
	call PAVZA1W		;ca 60uS nizek pin
	call H1WIRE		;1wire pin visok
	movlw .8
	call PAVZA1W		;pavza dolzine ca 420us
;	bcf ERR_1W
;	btfsc PIN_1WIRE		;kontrola prisotnosti senzorja
;	bsf ERR_1W		;senzorja ni na vodilu
	movlw .41
	call PAVZA1W
	return
		
;--------------------------------------------------
;procedura poslje podatke na 1wire vodilo
;--------------------------------------------------
VPIS1W
	movwf DATA_1W
	movlw .8
	movwf COUNT_1W
Z_VPIS1W
	call L1WIRE		;nizek 1Wpin
	nop
	nop
	nop
	nop
	nop
	rrf DATA_1W,f
	btfsc STATUS,C
	call H1WIRE
	movlw .6
	call PAVZA1W
	call H1WIRE
	decfsz COUNT_1W,f
	goto Z_VPIS1W
	return
	
;-------------------------------------------------
;procedura prebere podatke z vodila 1wire
;-------------------------------------------------
BRANJE1W
	clrf DATA_1W
	movlw .8
	movwf COUNT_1W
Z_BRANJE_1W
	call L1WIRE
	nop
	nop
	nop
	nop
	nop
	nop
	call H1WIRE
	nop
	nop
	nop
	nop		
	clrc
	btfsc PIN_1WIRE
	setc
	rrf DATA_1W,f
	movlw .6
	call PAVZA1W
	decfsz COUNT_1W,f
	goto Z_BRANJE_1W
	movf DATA_1W,W
	return
	
	
;-------------------------------------------------
;procedura preklopi 1wire pin na izhod z nizkim 
;stanjem
;-------------------------------------------------
L1WIRE
	bcf PIN_1WIRE
	bsf STATUS,RP0
	bcf PIN_1WIRE
	bcf STATUS,RP0
	return
;-------------------------------------------------
;procedura preklopi 1wire pin na vhod  
;
;-------------------------------------------------
H1WIRE
	bsf STATUS,RP0
	bsf PIN_1WIRE
	bcf STATUS,RP0
	return	
	
;--------------------------------------------------
;procedura definira pavzo pribliznbe dolzine W*10
PAVZA1W
	movwf TMP_1WIRE
ZP1W
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	decfsz TMP_1WIRE,f
	goto ZP1W 
	return
	
	
;--------------------------------------------------	
;branje temperature
;--------------------------------------------------
MERITEV_T	
	call RESET1W		;reset senzorja
	movlw 0xCC		;preskok branja ID
	call VPIS1W
	movlw 0x44		;vkljucitev konverzije
	call VPIS1W
;	btfss PIN_1WIRE		;cakam na konec konverzije
;	goto $-1
	call RESET1W		;reset senzorja	
	movlw 0xCC		;preskok branja ID
	call VPIS1W
	movlw 0xBE		;branje scratchpad
	call VPIS1W
	call BRANJE1W		;branje nizkega registra
	movwf L_RES
	call BRANJE1W		;branje viskokega reigstra
	movwf H_RES
	return	
	

;----------------------------------------
;glavna procedura	
;----------------------------------------	
GLAVNI
	clrf PORTA
	clrf PORTB
	clrf ST_ZNAKOV
	movlw b'111'
	movwf CMCON		;izklop komparatorjev 
	bsf STATUS,RP0
	movlw .12	;25=BRGH=0==2400kb  12=BRGH=1==19200
	movwf SPBRG	;baud rate generator	4Mhz 2400
	bsf TXSTA,TXEN	;vklop TX
	bsf TXSTA,BRGH	;velika brzina
	movlw b'1111'
	movwf TRISB	;rb3-rb7 izhodi
	bcf EN
	bcf RW
	bcf RS
	bsf PIE1,RCIE	;vklop prekinitve RX
	bcf STATUS,RP0
	bsf RCSTA,SPEN
	call INC_LCD
	clrf STEVEC
	bsf INTCON,GIE
	bsf INTCON,PEIE
	bsf RCSTA,CREN
NAPIS1				;izpis 1.vrstice
	movf STEVEC,W		;
	call TABELA1
	movwf TMP		
	movf TMP,f		;konec tabele oznacujem z 0
	btfsc STATUS,Z		;je tabele konec?
	goto NAPIS2		;da
	movwf TXREG		;ne posljem 
	call CAKAJ		;cakam da je posiljanja konec
	incf STEVEC,f		;povecam stevec
	goto NAPIS1
	

NAPIS2	
	clrf STEVEC
NAPIS2a	
	movf STEVEC,W		;
	call TABELA3
	movwf TMP		
	movf TMP,f		;konec tabele oznacujem z 0
	btfsc STATUS,Z		;je tabele konec?
	goto NAPIS3		;da
	movwf TXREG		;ne posljem 
	call CAKAJ		;cakam da je posiljanja konec
	incf STEVEC,f		;povecam stevec
	goto NAPIS2a
NAPIS3	
	call MERITEV_T
	rrf L_RES,w
	clrw
	btfsc STATUS,C
	movlw .5
	movwf DECIMALKA
	clrc
	rrf L_RES,W
	call HEX_DEC
	movf STICA,W
	btfsc STATUS,Z
	movlw .10
	call TABELA2
	movwf TXREG
	call CAKAJ
	movf DTICA,W
	call TABELA2
	movwf TXREG
	call CAKAJ
	movf ENICA,W
	call TABELA2
	movwf TXREG
	movlw '.'
	movwf TXREG
	call CAKAJ
	movf DECIMALKA,W
	call TABELA2
	movwf TXREG
	call CAKAJ
	movlw ''
	movwf TXREG
	call CAKAJ
	movlw 'C'
	movwf TXREG	
	call CAKAJ
	call PAUZA
	movlw .7
	movwf STEVEC
ZANKA1	
	movlw .8
	movwf TXREG
	call CAKAJ
	decfsz STEVEC,f
	goto ZANKA1
	bcf INTCON,GIE
	call LCD_TEST
	bsf INTCON,GIE
	goto NAPIS3
	
LCD_TEST
	movlw VRSTA1
	call UKAZ
	call PAVZA4_1mS
	movf STICA,w
	btfsc STATUS,Z
	movlw .10
	call TABELA2	
	call NA_LCD
	movf DTICA,w
	call TABELA2
	call NA_LCD
	movf ENICA,W
	call TABELA2
	call NA_LCD
	movlw ','
	call NA_LCD
	movf DECIMALKA,w
	call TABELA2
	call NA_LCD
	movlw b'11011111'
	call NA_LCD
	movlw 'C'
	call NA_LCD
	return
	
;**********************************************************
;procedure LCD



NA_LCD
	bsf RS
UKAZ
	movwf LCD_TMP
	movlw b'1111'
	andwf PORTB,f	;pobrisem 4 gronje bite
	movf LCD_TMP,W
	andlw b'11110000'
	iorwf PORTB,f
	bsf EN
	nop
	bcf EN
	movlw b'1111'
	andwf PORTB,f
	swapf LCD_TMP,w
	andlw b'11110000'
	iorwf PORTB,f
	bsf EN
	nop
	bcf EN
	bcf RS
	call PAVZA40uS
	return





;-----------------------------------------------------
;inicializacija LCD-ja
;-----------------------------------------------------
INC_LCD
	call PAVZA15mS
	movlw b'00110000'
	movwf PORTB
	bsf EN
	nop
	bcf EN
	call PAVZA4_1mS
	bsf EN
	nop
	bcf EN
	call PAVZA40uS
	call PAVZA40uS
	call PAVZA40uS
	bsf EN
	nop
	bcf EN
	call PAVZA4_1mS
	movlw b'00100000'
	movwf PORTB
	bsf EN
	nop
	bcf EN
	call PAVZA40uS
	movlw b'00100000'	;*4 bitna operacija
	movwf PORTB
	bsf EN
	nop
	bcf EN
	movlw b'10000000'
	movwf PORTB
	bsf EN
	nop
	bcf EN			;*
	call PAVZA40uS
	clrf PORTB
	bsf EN
	nop
	bcf EN
	bsf PORTB,7
	bsf EN
	nop
	bcf EN			;displej off,cursor off,blink off
	call PAVZA40uS
	clrf PORTB
	bsf EN
	nop
	bcf EN
	movlw b'11110000'
	movwf PORTB
	bsf EN
	nop
	bcf EN			;displej on, cursor on, bilink on
	call PAVZA4_1mS
	clrf PORTB
	bsf EN
	nop
	bcf EN
	movlw b'01100000'	;insert,scrool 
	movwf PORTB
	bsf EN
	nop
	bcf EN
	call PAVZA40uS
	return
	
	


;----------------------------------------
;pavza 15mS
;----------------------------------------	
PAVZA15mS
	movlw .20
	movwf T1_LCD
	movlw .121
	movwf T2_LCD
P15mS	
	decfsz T1_LCD,f
	goto P15mS
	decfsz T2_LCD,F
	goto P15mS
	return 	

;---------------------------------------
;pavza 4.1ms
;---------------------------------------
PAVZA4_1mS
	movlw .100
	movwf T2_LCD
	call PAVZA40uS
	decfsz T2_LCD,f
	goto $-2
	return

	
;---------------------------------------
;trajanje pavze ca 40us
;---------------------------------------
PAVZA40uS	
	movlw .11
	movwf T1_LCD
	decfsz T1_LCD,f
	goto $-1
	return



	
	END	;eof	